package com.liang.dao;

import com.liang.entity.PrjDivisioncompany;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;

/**
 * 单位分工：子课题单位(PrjDivisioncompany)表数据库访问层
 *
 * @author makejava
 * @since 2023-04-01 19:05:26
 */
public interface PrjDivisioncompanyDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    PrjDivisioncompany queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param prjDivisioncompany 查询条件
     * @param pageable           分页对象
     * @return 对象列表
     */
    List<PrjDivisioncompany> queryAllByLimit(PrjDivisioncompany prjDivisioncompany, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param prjDivisioncompany 查询条件
     * @return 总行数
     */
    long count(PrjDivisioncompany prjDivisioncompany);

    /**
     * 新增数据
     *
     * @param prjDivisioncompany 实例对象
     * @return 影响行数
     */
    int insert(PrjDivisioncompany prjDivisioncompany);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<PrjDivisioncompany> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<PrjDivisioncompany> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<PrjDivisioncompany> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<PrjDivisioncompany> entities);

    /**
     * 修改数据
     *
     * @param prjDivisioncompany 实例对象
     * @return 影响行数
     */
    int update(PrjDivisioncompany prjDivisioncompany);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 通过子课题删除数据
     *
     * @param zkt
     * @return
     */
    int deleteByZkt(Integer zkt);

    /**
     * 批量删除子课题单位分工
     *
     * @param zktList
     * @return
     */
    int batchDeleteByZkt(List<Integer> zktList);

    /**
     * 删除项目子课题单位分工
     *
     * @param xm
     * @return
     */
    int deleteByXm(Integer xm);

    /**
     * 批量删除子课题单位分工
     *
     * @return
     */
    int batchDeleteByXm(List<Integer> xmList);

    /**
     * 获取子课题分工单位
     *
     * @param zkt
     * @return
     */
    List<PrjDivisioncompany> getCompanyList(Integer zkt);
}

